	var Settings = System.Gadget.Settings;
	System.Gadget.onSettingsClosing = SettingsClosing;
	
	var URL = "http://www.meteonova.ru/proxy.php";
	var countRequest = 0;
	var countriesStorage = new Array;
	var districtsStorage = new Array;	
	var citiesStorage = new Array;
	var countryId = 156;
	var districtId = 50;
	
	function itemData(id, name) {
		this.id = id;
		this.name = name;				
	}
	
	function init() {
		if (!dictObj) return;
		setStaticContent();
		setChosenList();
		loadCountriesList();
		loadDistrictsList(countryId);
	}
	
	function setChosenList() {
		var arr = getCitiesData();
		if(!arr) arr = getDefaultCityData();
		fillSelectList("chosenList", arr);
		arr = null;
	}
	
	function getCitiesData() {
		var strCitiesList = getString("chosenCitiesStorage");
		if (strCitiesList) {
			var arr = strCitiesList.split(",");
			arr2 = new Array();
			for (var i=0; i<arr.length; i++) {
				id = arr[arr.length-(i+1)].split("_")[0];
				name = arr[arr.length-(i+1)].split("_")[1];				
				arr2.push(new itemData(id, name));
			}
			arr = null;				
			return arr2;
		}
		else return null;
	}
	
	function getDefaultCityData() {
		var arr = new Array();
		arr.push(new itemData('27612', dictObj.defCityName));
		return arr;
	}
	
	function getString(str) {
	  if (Settings.read("SettingsExist")) {
	    return Settings.readString(str);
	  }
	  else return null;
	}
	
	function addCity() {
		var obj = document.getElementById("tlist");  
		var id = obj.options[obj.selectedIndex].value;
		var name = obj.options[obj.selectedIndex].text;
		if (isCityChosenList(id)) return;
		var arr = new Array();
		arr.unshift(new itemData(id, name));
		fillSelectList("chosenList", arr);	
		arr = null;
	}
	
	function delCity() {
		var obj = document.getElementById("chosenlist");
 		if(obj.options.length == 1) return;
 		if (obj.selectedIndex == -1) return;
 		obj.remove(obj.selectedIndex);		 		
 		obj.selectedIndex = obj.options.length-1;		
	}
	
	function up() {
		var obj=document.getElementById("chosenlist");
		var i=obj.selectedIndex;
	 	if(i>0)
	 	{
	   	e1=obj.options[i];
	   	e2=obj.options[i-1];  	
	   	obj.insertBefore(e1,e2);   	
	 	}		
	}
	
	function down(){
		var obj=document.getElementById("chosenlist");
		var i=obj.selectedIndex;
	 	if(i<obj.options.length-1)
	 	{
	   	e1=obj.options[i];
	   	e2=obj.options[i+1];		   	
	   	obj.insertBefore(e2,e1); 	
	 	}
	}		
	
	function isCityChosenList(id) {
		var obj = document.getElementById("chosenlist");
		for(var i=0; i<obj.options.length; i++)
			if (obj.options[i].value == id) return true;
		return false;	
	}
	
	function SettingsClosing(event) {
		if (event.closeAction == event.Action.commit) {
			var obj=document.getElementById("chosenlist");
			var arr = new Array();
			for(var i=0; i<obj.options.length; i++)
				arr[i] = obj.options[i].value+"_"+obj.options[i].text;	
			if (!Settings.read("SettingsExist"))  Settings.write("SettingsExist", true);
			Settings.write("chosenCitiesStorage", arr.join(","));
			Settings.write("selectedIndex", '0');
			arr = null;
		} 
	}	
	
	////////////////////////////////////////////////////////////////////////////////////////////////////

	function loadCountriesList() {
		countRequest++;
		countriesStorage[0] = new Array();
		loadList("&id="+countRequest+"&searchby=countries&r="+Math.random(), countriesStorage[0], "clist");		
	}	
	
	function loadDistrictsList(id) {
		countryId = id;
		countRequest++;
    districtsStorage[countryId] = new Array();	 	
		loadList("&id="+countRequest+"&searchby=regions&c_id="+countryId+"&r="+Math.random(), districtsStorage[countryId], "dlist");			
	}	
	

	function getDistrictsList(obj) {
		clearList("dlist"); 
		clearList("tlist"); 		
		loadDistrictsList(obj.options[obj.selectedIndex].value);
	}	
	
	function getCitiesList(obj) {
		clearList("tlist"); 
		loadCitiesList(countryId, obj.options[obj.selectedIndex].value);
	}
	
	function loadCitiesList(cid, did) {
		countRequest++;
    citiesStorage[cid+'_'+did] = new Array();	
    if (did != 0) 	
			loadList("&id="+countRequest+"&searchby=cities&d_id="+did+"&r="+Math.random(), citiesStorage[cid+'_'+did], "tlist");	  
    else if (cid != 0) 
    	loadList("&id="+countRequest+"&searchby=cities&c_id="+cid+"&r="+Math.random(), citiesStorage[cid+'_'+did], "tlist"); 			
	}
	
	function loadList(GetParam, itemstorage, strid) {
		var loadData = new LoadData(itemstorage, strid);
		loadData.getData(URL+"?lang="+dictObj.lang+GetParam);		
	}
	
	function LoadData(itemstorage, strid){
	    this.XMLObj = null;
	    this.itemstorage = itemstorage;
	    this.id = strid;
	    
	    this.getData=function(URL) {
	        if (this.XMLObj == null)
	            this.XMLObj = new XMLHttpRequest();

	        if (this.XMLObj) {
	            this.XMLObj.onreadystatechange = this.LoadDataCallbackFunction (this.XMLObj, this.itemstorage, this.id);
	            this.XMLObj.open("GET", URL, true);
	            this.XMLObj.send(null);
	        }
	    }

	    this.LoadDataCallbackFunction=function(XMLObj, itemstorage, id) {
	        return function() {
	            if (XMLObj.readyState == 4) {
	            	if (XMLObj.status == 200 ) {
								 	itemstorage = eval( "[" + XMLObj.responseText + "]" );
								 	fillSelectList(id, itemstorage);
	               	XMLObj= null;
	              }
	            }
	        }
	    }
	}	
	
	function clearList(strid) {
		var obj = document.getElementById(strid);
		if (obj)
			while (obj.childNodes.length) {	
				obj.removeChild(obj.firstChild);
			}	
	}	
	
	//////////////////////////////////////////////////////////////////////////////////////////////////
	
	function fillSelectList(strid, arr) {
		var selectIndex = 0;
		var obj = document.getElementById(strid);
		if (obj) {
			for(var i=0; i<arr.length; i++) {
				for(var j=0; j<obj.options.length; j++) 
					if (obj.options[j].value == arr[i].id) {
						setSelectedIndex(strid, j);
						return;	
					}	
				var newOption = document.createElement("OPTION");
      	newOption.value = arr[i].id;
      	newOption.text = arr[i].name;
      	if (strid == "chosenList") 
      		obj.add(newOption, 0);  //only IE
      	else
      		obj.options[obj.options.length] = newOption;
      	if(strid == "dlist") var selid = districtId;
      	if(strid == "clist") var selid = countryId;      
      	if (newOption.value == selid) selectIndex = i;      	
      	newOption = null;
    	}
    	if(strid == "chosenList") selectIndex = obj.options.length-1;
  	}
		setSelectedIndex(strid, selectIndex);
		if(strid == "dlist") {
			if (arr.length == 0) districtId = 0;
			else districtId = obj.options[selectIndex].value;			
			loadCitiesList(countryId, districtId);
		}
	}
	
	function setSelectedIndex(strid, selectIndex) {
		var obj = document.getElementById(strid);
		if (obj) obj.selectedIndex = selectIndex;	
	}	
	
////////////////////////////////////////////////////////////////////////////////////////////////////

var inputDefaultValue = dictObj.settings[4];

function xButtonClick(obj) {
	document.getElementById('inputText').value = '';
	obj.style.visibility = 'hidden';
	document.getElementById('inputText').focus();			
}

function inputTextFocus(obj) {
	closeSuggestList();
	obj.style.color='#000';
	if (obj.value == inputDefaultValue) {
		obj.value = '';
		document.getElementById('xButton').style.visibility = 'hidden';	
	}	
}

function inputTextBlur(obj) {
	if (obj.value == '') {		
		obj.style.color='#8c8c8c';
		obj.value = inputDefaultValue;
		document.getElementById('xButton').style.visibility = 'visible';	
	}
}

var searchTimeOut = null;

function inputTextKeyUp(obj) {
	document.getElementById('inputTextHidden').value = '';	
	clearTimeout(searchTimeOut);	
	var code = (event.charCode) ? event.charCode : event.keyCode;
	switch(code) {
    case 13:
    	selectCity();
    	addCityFromSearch();		
    break; 			      
    case 38:
    	setBackground(-1);		
    break; 
    case 40:
    	setBackground(1);	
    break; 
		default:
			document.getElementById('btn_add_search_city').disabled = true;		 
			document.getElementById('xButton').style.visibility = 'hidden';
			document.getElementById('spinner').style.visibility = 'visible';						
			searchTimeOut = setTimeout(function() {
				countRequest++;
				var loadData = new LoadDataSearch();
				loadData.getData(URL+"?lang="+dictObj.lang+"&searchby=cities&id="+countRequest+"&fchar="+escape2(obj.value)+"&mcntcities=4");				
			}, 200);
    break;
    	    		      	  				
	} 
}

function LoadDataSearch(){
  this.XMLObj = null;
  this.getData=function(URL) {
  	if (this.XMLObj == null)
    	this.XMLObj = new XMLHttpRequest();

    if (this.XMLObj) {
    	this.XMLObj.onreadystatechange = this.LoadDataCallbackFunction (this.XMLObj);
      this.XMLObj.open("GET", URL, true);
      this.XMLObj.send(null);
    }
  }

  this.LoadDataCallbackFunction=function(XMLObj) {
  	return function() {
    	if (XMLObj.readyState == 4 && XMLObj.status == 200) {
    		var itemstorage = eval( "[" + XMLObj.responseText + "]" );
				fillSuggestList(XMLObj, itemstorage);
        XMLObj= null;
      }
   	}
  }
}

var focus_idx = -1;	

function fillSuggestList(XMLObj, itemstorage) {
	focus_idx = -1;
	var arr = null;
	var data="<table cellspacing=\"0\">";
	if (itemstorage.length>0)
	for(var i=0; i<itemstorage.length; i++)
		try {
	 		var district = itemstorage[i].d_name!=null?itemstorage[i].d_name+', ':'';
	 		var country = itemstorage[i].c_name;
	  	data += "<tr><td id=\"Suggestionstd"+i+"\" onclick=\"addCityFromSearch();\"><a onmouseover=\"setMouseOver("+i+");\" id=\"Suggestionstd_a"+i+"\" href=\"javascript: void(0);\"><span id=\"Suggestionstd_a_span_city"+i+"\" class=\"city\" value=\""+itemstorage[i].id+"\">"+itemstorage[i].name+"</span> <span>"+district+country+"</span></a></td></tr>";
	 	}
	 	catch(err){ break; }  
	else 
	  data+="<tr><td id=\"Suggestionstd0\">"+dictObj.settings[11]+"</td></tr>";
  data+="</table>";
	document.getElementById('xButton').style.visibility = 'visible';
	document.getElementById('spinner').style.visibility = 'hidden';	  
  document.getElementById('autoSuggestionsList').innerHTML = data;
	document.getElementById('suggestionsBox').style.display = 'block';
}

var max_idx = 0;

function setBackground(step) {
	for (var i=0; i<10; i++) 
		if (document.getElementById('Suggestionstd_a'+i))
			max_idx = i;		
	focus_idx += step;
	if (!document.getElementById('Suggestionstd_a'+focus_idx)) 
		focus_idx = step==1?0:max_idx;	
	setMouseOver(focus_idx);
}

function setMouseOver(idx) {
	clearHoverSuggestList();	
	focus_idx = idx;
	document.getElementById('Suggestionstd_a'+focus_idx).setAttribute('className', 'hover');
	selectCity();
	document.getElementById('btn_add_search_city').disabled = false;	
}

function selectCity() {
	document.getElementById('inputText').value = document.getElementById('Suggestionstd_a_span_city'+focus_idx).innerHTML;	
	document.getElementById('inputTextHidden').value = document.getElementById('Suggestionstd_a_span_city'+focus_idx).getAttribute('value');
	document.getElementById('xButton').style.visibility = 'visible';
}

function addCityFromSearch() {
	var arr = [];
	arr.unshift(new itemData(document.getElementById('inputTextHidden').value, document.getElementById('inputText').value));
	fillSelectList("chosenList", arr);	
	arr = null;	
	document.getElementById('inputText').focus();
}

function closeSuggestList() {
	document.getElementById('suggestionsBox').style.display = 'none';	
}

function clearHoverSuggestList() {
	for (var i=0; i<10; i++) { 
		var obj = document.getElementById('Suggestionstd_a'+i);
		if (obj) obj.setAttribute('className', '');
	}		
}

function setStaticContent() {
	document.getElementById('countries').innerHTML = dictObj.settings[0];	
	document.getElementById('districts').innerHTML = dictObj.settings[1];	
	document.getElementById('cities').innerHTML = dictObj.settings[2];
	document.getElementById('btn_add_city').innerHTML = dictObj.settings[3];	
	document.getElementById('inputText').value = dictObj.settings[4];	
	document.getElementById('btn_add_search_city').innerHTML = dictObj.settings[5];
	document.getElementById('selectedList').innerHTML = dictObj.settings[6];
	document.getElementById('btn_up').innerHTML = dictObj.settings[7];
	document.getElementById('btn_down').innerHTML = dictObj.settings[8];
	document.getElementById('btn_del').innerHTML = dictObj.settings[9];
	document.getElementById('meteosystems').innerHTML = dictObj.settings[10];												
}

var trans = [];
for (var i = 0x410; i <= 0x44F; i++) trans[i] = i - 0x350; // А-Яа-я
trans[0x401] = 0xA8;    // Ё
trans[0x451] = 0xB8;    // ё
trans[0x457] = 0xBF;    // ї
trans[0x407] = 0xAF;    // Ї
trans[0x456] = 0xB3;    // і
trans[0x406] = 0xB2;    // І
trans[0x404] = 0xBA;    // є
trans[0x454] = 0xAA;    // Є

escape2 = function(str) {
  var res="";

  for (var i = 0; i < str.length; i++)
  {
    var n = str.charCodeAt(i);
    if (typeof trans[n] != 'undefined')
    {
      n = trans[n];
      res=res+escape(String.fromCharCode(n));
    }
    else
    {
      n = str.charAt(i);
      res=res+n;
    }

  }
  return res;
}

