function dockedGadgetFunction() {
	this.docObj = document;
	this.divBodyObj = null;
	
	this.url = 'http://www.meteonova.'+dictObj.domain;
	
	this.width = '130px';
	this.height = '124px';
	
	this.getBodyObj = function() {
		return this.docObj.getElementById("dockblock");
	}
	
	this.showGadget = function() {
	  with(this.docObj.body.style) {
	    width = this.width;
	    height = this.height;
	  }
		this.divBodyObj.style.display="block";
		backgrounddock.style.width = this.width;
		backgrounddock.style.height = this.height;
		backgrounddock.src = "../res/dock/background.png";
		this.divBodyObj.innerHTML = this.displayGadget();		
		this.setPreloaderStyle();
	}
	
	this.displayGadget = function() {
		return '<div class="docklogo"></div>'+
			'<div id="dockfrcblock"></div>'+
			'<div class="dockfrcblock">'+
				'<div>'+
					'<div id="dockphenomena" onClick="onShowFlyout();"></div>'+
					'<div class="dockdata">'+
						'<div id="dockday"></div>'+
						'<div id="qqq" style="font-size: 10px;"></div>'+							
						'<div id="docktemper"></div>'+					
					'</div>'+
				'</div>'+
			 '</div>'+
		'<div class="dockcityname"><table><tr><td id="dockcityname"></td></tr></table></div>';			
	}

	this.showCityName = function(cityData) {
		if (cityData.name.length>18) {
          	this.docObj.getElementById("dockcityname").style.fontSize = "11px";
		}
		if (cityData.name.length>20) {
          	this.docObj.getElementById("dockcityname").style.fontSize = "10px";
		}
		if (cityData.name.length<=15) {
          	this.docObj.getElementById("dockcityname").style.fontSize = "12px";
		}
		this.setContent("dockcityname", "<a class='a_undecor' href='"+this.url+"/frc/"+cityData.id+".htm'>"+cityData.name+"</a>");
	}
	
	this.showFlash = function(cityData) {
		return null;
	}

	this.showFrc = function(cityData) {
		var forecast = null;
		for (var i=0; i<cityData.forecasts.length; i++)
			if (cityData.forecasts[i].tod==2) {
				this.hideLayer('preloader');
				forecast = cityData.forecasts[i];
				//this.setContent("dockday", forecast.day+", "+weekdays[forecast.weekday-1]);
				this.setContent("dockday", forecast.day+"/"+forecast.month+", "+dictObj.weekdays[forecast.weekday-1]);
				this.setContent("docktemper", cityData.forecasts[i].t+"&deg;");
				this.setPhenomena(cityData.forecasts[i].phenomena);
				break;
			}
	}

	this.hide = function() {
		this.divBodyObj.style.display="none";
	}

	this.setPreloaderStyle = function() {
		var obj = this.docObj.getElementById("preloader");
		obj.style.top = "40px";
		obj.style.left = "41px";
	}

	this.hideLayer = function(str_id) {
		var obj = this.docObj.getElementById(str_id);
		if (obj) obj.style.display = "none";
	}

	this.showLayer = function(str_id) {
		var obj = this.docObj.getElementById(str_id);
		if (obj) obj.style.display = "block";
	}

	this.setContent = function(strId, str) {
		var obj = this.docObj.getElementById(strId);
		if (obj) obj.innerHTML = str;
	}

	this.setPhenomena = function(iconName) {
		var obj = this.docObj.getElementById("dockphenomena");
		if (obj) {
			var phenomena = "<img src = '../res/icons/"+iconName+".png'>";
			if (phenomena!=obj.innerHTML) obj.innerHTML = "<img src = '../res/icons/"+iconName+".png'>";
		}
	}

	this.showNews = function() {
	}
}