	var p=0;
	var old_version = "1.2.0.0";
	System.Gadget.settingsUI = "settings.html";	
	var Settings = System.Gadget.Settings;
	var flyout = System.Gadget.Flyout;

	var id = null;
	var cashTime = 60*60000;
	var frcTimeout = 3000;
	
	var URL = "http://www.meteonova.ru/xml/";

	var dockedGadget = null;
	var undockedGadget = null;
	var gadget = null;

	var interval = null;

	var updateCityList = true;

	var p=0;

	function itemData(id, name) {
		this.id = id;
		this.name = name;
		this.timeCreate = 0;
		this.forecasts = new Array();
		this.xmltttpReq = null;
	}

	var citiesData = new Array();

	function forecastData() {
		this.day = null;
		this.month = null;
		this.year = null;
		this.weekday = null;
		this.tod = null;
		this.hour = null;
		this.cl = null;
		this.pt = null;
		this.altimg = null;
		this.phenomena = null;
		this.p = null;
		this.t = null;
		this.hum = null;
		this.wd = null;
		this.ws = null;
	}

	var arrayNews = null;
	function NewsParam() {
		this.title = null;
		this.description = null;
		this.pict = null;
		this.link = null;
		this.category = null;
		this.now = null;
	}
	
	function init() {
		if (!dictObj) return;
		System.Gadget.onSettingsClosed = SettingsClosed;	
		System.Gadget.onDock = setGadget;
		System.Gadget.onUndock = setGadget;		
		setGadget();				
	}
	
	function initFlyout() {
	   with (flyout.document.body.style) {
	      width = 400;
	      height = 400;
	   }
	   bgflyout.style.width = "400px";
  	 bgflyout.style.height = "400px";
	   bgflyout.src = "../res/undock/background.png";
	}

	function onShowFlyout() {
		if (!flyout.show) flyout.file = "flyout.html";
		flyout.show = !flyout.show;
		flyout.onShow = setFlyoutGadget;
		flyout.onHide = init;   
	}

	function setGadget() {
		setGadgetState(); 
		showContent();				
	}
	
	function setFlyoutGadget() {
		if (!undockedGadget) undockedGadget = new undockedGadgetFunction(true);
	  gadget = undockedGadget;
	  gadget.docObj = flyout.document;
	  gadget.divBodyObj = gadget.getBodyObj();
	  gadget.showGadget = function() {
	  	gadget.showFlyoutGadget();	
	  }	  
	  showContent(); 			
	}

	function setGadgetState() {

    if (!undockedGadget) undockedGadget = new undockedGadgetFunction();
	  if (!dockedGadget) dockedGadget = new dockedGadgetFunction();
	  
	  dockedGadget.docObj = document;
	  undockedGadget.docObj = document;
	  dockedGadget.divBodyObj = dockedGadget.getBodyObj();
	  undockedGadget.divBodyObj = undockedGadget.getBodyObj();		  	

	  if(!System.Gadget.docked) {
	  	dockedGadget.hide();
	    gadget =  undockedGadget;
		  gadget.showGadget = function() {
		  	gadget.showUndokedGadget();	
		  }		        
		}
	  else if (System.Gadget.docked) { 	
	    	   undockedGadget.hide();
	    		 gadget = dockedGadget;
	       }             	       	       		
  }
  
  function showContent() {
  	clearTimeout(interval);	
  	gadget.showGadget();  	
		var cityData = getCityData();	
		id = cityData.id.toString();	
		if (!isCitiesData(id)) citiesData[id] = cityData;
		if (cityData.xmltttpReq) cityData.xmltttpReq = null; 
		gadget.showCityName(cityData);
	  gadget.showLayer('dockfrcblock');
		gadget.showLayer('preloader');		
		if (isTimeOut()) {
			getForecast(citiesData[id]);
			getNewsContent();
		}	
		else {
			gadget.hideLayer('preloader'); 
			gadget.hideLayer('dockfrcblock'); 
			gadget.showFrc(citiesData[id]);
			gadget.showNews(); 			
		}
		gadget.showFlash(cityData);
  }
  
  function isTimeOut() {
  	if (parseInt(getTimeNow()-citiesData[id].timeCreate)>parseInt(cashTime))
  		return true;
  	else return false;	
  }
	
  function getCityData() {
		var selectedIndex = getString("selectedIndex");
		if(!selectedIndex) selectedIndex = 0;
	  return getChosenCity(selectedIndex);  	
  }	

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	function getForecast(cityData) {	
	  clearTimeout(interval);			
		cityData.forecasts = null;
		cityData.forecasts = new Array();
		cityData.xmltttpReq = new XMLHttpRequest();
		cityData.xmltttpReq.onreadystatechange = function() {
			if (cityData.xmltttpReq.readyState == 4)
				if (cityData.xmltttpReq.status == 200) {
					if (setForecasts(cityData)) gadget.showFrc(citiesData[id]);
					else cityData.xmltttpReq = null;
					gadget.hideLayer('preloader');
					gadget.hideLayer('dockfrcblock');
					interval = setTimeout(function(){getForecast(cityData)}, 30*60000);
				}
				else {
					if (frcTimeout>24000) frcTimeout = 3000;
					frcTimeout*=2;
					interval = setTimeout(function(){getForecast(cityData)}, frcTimeout);
				}
		}
		cityData.xmltttpReq.open("GET", URL+cityData.id+".xml?&ver="+old_version+"&r="+Math.random(1000), true);
		cityData.xmltttpReq.send(null);
	}

	function setForecasts(cityData){
		var xmlElement=null;

		if (cityData.xmltttpReq.responseXML) xmlElement = cityData.xmltttpReq.responseXML.documentElement;

		var forecasts = xmlElement.getElementsByTagName("FORECAST");

		if (forecasts.length == 0) return false;

		for (var i=0; i<forecasts.length-1; i++) {
			var forecast = parseXML(forecasts[i]);
			cityData.forecasts.push(forecast);
			delete(forecast);
		}
		cityData.timeCreate=getTimeNow();
		cityData.xmltttpReq = null;
		return true;
	}

	function parseXML(tod_forecast) {
	  var forecast = new forecastData();
	  forecast.day = tod_forecast.getAttribute("day");
	  forecast.month = tod_forecast.getAttribute("month");
	  forecast.year = tod_forecast.getAttribute("year");
	  forecast.weekday = tod_forecast.getAttribute("weekday");
	  forecast.tod = tod_forecast.getAttribute("tod");
	  var phenomena = tod_forecast.getElementsByTagName("PHENOMENA");
	  forecast.cl = phenomena[0].getAttribute("cloudiness");
	  forecast.pt = phenomena[0].getAttribute("precipitation");
	  forecast.ts = phenomena[0].getAttribute("spower");
	  var temper = tod_forecast.getElementsByTagName("TEMPERATURE");
	  forecast.t = (parseInt(temper[0].getAttribute("max"))+parseInt(temper[0].getAttribute("min")))/2;
	  var pressure = tod_forecast.getElementsByTagName("PRESSURE");
	  forecast.p = (pressure[0].getAttribute("max")+pressure[0].getAttribute("min"))/2;
	  var wind = tod_forecast.getElementsByTagName("WIND");
	  forecast.wd = dictObj.wind_directions[wind[0].getAttribute("direction")];
	  forecast.ws =Math.round((parseInt(wind[0].getAttribute("max"))+parseInt(wind[0].getAttribute("min")))/2);
	  if (forecast.ws == 0) forecast.wd = "calm";
	  var relwet = tod_forecast.getElementsByTagName("RELWET");
	  forecast.hum = Math.round((parseInt(relwet[0].getAttribute("max"))+parseInt(relwet[0].getAttribute("min")))/2);
	  forecast = buildFrc(forecast);
		return forecast;
	}

	function buildFrc(param) {
		if (param.day.length==1) param.day='0'+param.day;
		if (param.month.length==1) param.month='0'+param.month;

	    if ((param.tod == 0) || (param.tod == 3)) var pref = "n";
		if ((param.tod == 1) || (param.tod == 2)) var pref = "d";

		switch (param.cl) {
			case '0':
			param.phenomena=0;
			break;
			case '1':
			param.phenomena=1;
			break;
			case '2':
			param.cl = 1;
			param.phenomena=2;
			break;
			case '3':
			param.cl = 8;
			param.phenomena=3;
			break;
   	}

		if ((param.pt==4) || (param.pt==5)){
			if (param.cl==1) { param.phenomena=4; }
			if (param.cl==8) { param.phenomena=5; }
		}

		if ((param.pt==6) || (param.pt==7)) {
		 if (param.cl==1) { param.phenomena=6; }
		 if (param.cl==8) { param.phenomena=7; }
		}

		if ((param.pt==8) || (param.ts==1)){
		  param.phenomena=8;
		}

		param.phenomena = pref+param.phenomena;

		if (param.t>0) param.t = "+"+param.t;

		return param;
	}

//////////////////////////////////////////////////////////////////////////////////////////////////

	function SettingsClosed(event) {
		if (event.closeAction == event.Action.commit) {			
			if (!System.Gadget.docked) gadget.setCityList();
			showContent();				
		}
	}

	function getChosenCity(num) {
		var arr = getCitiesData();
		if(!arr) arr = getDefaultCityData();
		return arr[num];
	}

	function getCitiesData() {
		var strCitiesList = getString("chosenCitiesStorage");
		if (strCitiesList) {
			var arr = strCitiesList.split(",");
			arr2 = new Array();
			for (var i=0; i<arr.length; i++) {
				id = arr[i].split("_")[0];
				name = arr[i].split("_")[1];
				arr2.push(new itemData(id, name));
			}
			arr = null;
			return arr2;
		}
		else return null;
	}

	function getDefaultCityData() {
		var arr = new Array();
		arr.push(new itemData('27612', dictObj.defCityName));
		return arr;
	}

	function getString(str) {
	  if (Settings.read("SettingsExist")) {
	    return Settings.readString(str);
	  }
	  else return null;
	}

	function setString(ident, str) {
		if (!Settings.read("SettingsExist"))
			Settings.write("SettingsExist", true);
		if (Settings.read("SettingsExist"))
			Settings.write(ident, str);
	}

	function isCitiesData(cityId){
		if (typeof(citiesData[cityId])=='undefined')
			return false;
		else return true;
	}

	function setContent(str) {
		document.getElementById("docktemper").innerHTML = str;
	}

//////////////////////////////////////////////////////////////////////////////////////////////////

	function getNewsContent() {
		gadget.hideLayer("undocknewscontent");
		getNews();
	}

	function getNews() {
		var xhr = new XMLHttpRequest();
		arrayNews = null;
		arrayNews = new Array();
		xhr.onreadystatechange = function() {
			if (xhr.readyState == 4)
				if (xhr.status == 200) {
					if (parseXMLNews(xhr))
						gadget.showNews();
					setTimeout(function(){getNews()}, 60*60000);
				}
				else {
					setTimeout(function(){getForecast(cityData)}, 10000);
				}	
		}
		xhr.open("GET", "http://www.meteonova.ru/news/export/meteonova.xml", true);
		xhr.send(null);
	}

	function parseXMLNews(xrequest) {
	   var newsitem = null;
	   newsitem = xrequest.responseXML.documentElement.getElementsByTagName('item');
	   if (!xrequest.responseXML) return false;
	   if (!newsitem) return false;
	   for(i=0; i<1; i++){
	      var news = new NewsParam;
	      for(j=0; j<newsitem[i].childNodes.length; j++) {
	           name=newsitem[i].childNodes[j].nodeName;
	           switch (name){
						    case 'title':
						    news.title = newsitem[i].childNodes[j].text;
						    break;
						    case 'link':
						    news.link = newsitem[i].childNodes[j].text;
						    break;
						    case 'description':
						    news.description = newsitem[i].childNodes[j].text;
						    break;
						    case 'category':
						    news.category = newsitem[i].childNodes[j].text;
						    break;
						    case 'enclosure':
						    if(!news.pict) news.pict = newsitem[i].childNodes[j].getAttribute("url");
						    break;
	           }
	      }
	      arrayNews[i]=news;
	      delete news;
	   }
	   newsTimeCreate = getTimeNow();
	   xrequest = null;
	   return true;
	}

//////////////////////////////////////////////////////////////////////////////////////////////////

	function getTimeNow(){
		var now = new Date();
		return now.getTime();
	}

/////////////////////////////////////////////////////////////////////////////////////////////////

	function onChangeCityList(value) {		
		setString('selectedIndex', value);
		if(!flyout.show) setGadget();
		else setFlyoutGadget();
		gadget.setContent('undockcityname', '');
		gadget.setContent('undockfrcblock', '');
		showContent();			
	}

/////////////////////////////////////////////////////////////////////////////////////////////////

	function goTo(url) {
		document.location=url;
	}