function undockedGadgetFunction(isFlyout) {
	this.docObj = null;
	this.divBodyObj = null;
	
	this.updateCityList = true;
	
	this.url = 'http://www.meteonova.'+dictObj.domain;

	this.width = '400px';
	this.height = '402px';
	
	this.isFlyout = isFlyout || false;
	
	this.getBodyObj = function() {
		return this.docObj.getElementById("undockblock");
	}	

	this.showUndokedGadget = function() {
	  with(this.docObj.body.style) {
	    width = this.width;
	    height = this.height;
	  }
	  this.divBodyObj.focus;
		this.divBodyObj.style.display="block";
		this.setPreloaderStyle();
		this.setPreloader2Style();
		backgrounddock.style.width = this.width;
		backgrounddock.style.height = this.height;
		backgrounddock.src = "../res/undock/background.png";
		this.divBodyObj.innerHTML = this.displayGadget();
		this.setCityList();
	}
	
	this.showFlyoutGadget = function() {
		this.divBodyObj.style.display="block";
		this.setPreloaderStyle();
		this.setPreloader2Style();		
		this.divBodyObj.innerHTML = this.displayGadget();				
		this.setCityList();
	}	
	
	this.showGadget = function() {
	}

	this.displayGadget = function() {
		//return '<div class="btn_reload" id="btn_reload" style="display: none;" onClick="goTo(\''+this.url+'/fan/gadget.htm\');"></div>'+
		return '<div class="update_block" id="update_block" onClick="goTo(\''+this.url+'/fan/gadget.htm\');">'+dictObj.update+'</div>'+
		'<div class="undocklogo"></div>'+
		'<div class="undockcityblock">'+
			'<div><table><tr><td id="undockcityname"></td><td id="undockcitylist" style="width: 120px;"><select style="width: 120px;" id="citylist" onChange="onChangeCityList(this.selectedIndex);"></select></td></tr></table></div>'+
		'</div>'+
		'<div id="undockfrcblock"></div>'+
		'<div class="flash10link">'+
			'<div>'+
				'<div class="text_11">'+dictObj.descriptions[4]+'</div>'+
				'<div id="flash"></div>'+
				'<div id="undockfrclink"></div>'+
			'</div>'+
		'</div>'+
		'<div class="undocknews">'+
			'<div class="undocknewslogo"></div>'+
			'<div id="undocknewscontent"></div>'+
		'</div>';
	}

	this.showCityName = function(cityData) {
		name = dictObj.pref_title+" <a href='"+this.url+"/frc/"+cityData.id+".htm'>"+cityData.name+"</a>";
		if (cityData.name.length<=13) {
          	this.docObj.getElementById("undockcityname").style.fontSize = "18px";
		}
		if (cityData.name.length>13) {
          	this.docObj.getElementById("undockcityname").style.fontSize = "16px";
		}
		if (cityData.name.length>17) {
          	this.docObj.getElementById("undockcityname").style.fontSize = "14px";
		}
		this.setContent("undockcityname", name);
	}
	
	this.showFlash = function(cityData) {
		var so = new SWFObject("../a16.swf", "flash", "50", "16", "8", "384b8e"); 
		so.addVariable('city', cityData.id);
		so.addVariable('clr', '384b8e');
		so.write('flash');
	}

	this.showFrc = function(cityData) {
			this.setContent("undockfrcblock", this.setFrcContent(cityData));
			this.setContent("undockfrclink", "<a href='"+this.url+"/frc/"+cityData.id+".htm'>"+dictObj.descriptions[5]+"</a>");
			var obj = this.docObj.getElementById("citylist");
			if (obj.length>0) selectedIndex = obj.selectedIndex;
			if (typeof vista_widget_version != "undefined")
				if (old_version!=vista_widget_version) this.showReloadButton();
	}

	this.hide = function() {
		this.divBodyObj.style.display="none";
	}

	this.setPreloaderStyle = function() {
		var obj = this.docObj.getElementById("preloader");
		obj.style.top = "150px";
		obj.style.left = "176px";
	}

	this.setPreloader2Style = function() {
		var obj = this.docObj.getElementById("preloader2");
		obj.style.top = "320px";
		obj.style.left = "176px";
	}

	this.hideLayer = function(str_id) {
		var obj = this.docObj.getElementById(str_id);
		if (obj) obj.style.display = "none";
	}

	this.showLayer = function(str_id) {
		var obj = this.docObj.getElementById(str_id);
		if (obj) obj.style.display = "block";
	}

	this.setContent = function(strId, str) {
		var obj = this.docObj.getElementById(strId);
		if (obj) obj.innerHTML = str;
	}

	this.setCityList = function() {
		var arr = getCitiesData();
		if(!arr) arr = getDefaultCityData();
		if (arr.length>1) {
			var obj = this.docObj.getElementById("citylist");
			this.fillCityList(arr);
			this.showCityList();
		}
		else this.hideCityList();
		arr = null;
	}

	this.fillCityList = function(arr) {
		var obj = this.docObj.getElementById("citylist");
		if (obj) {
			obj.options.length = 0;
			for(var i=0; i<arr.length; i++) {
				var newOption = this.docObj.createElement("OPTION");
    				newOption.value = arr[i].id;
    				newOption.text = arr[i].name;
    				obj.options[obj.options.length] = newOption;
    				if (i==getString('selectedIndex')) obj.selectedIndex=i;
    				newOption = null;
    			}
  		}
	}

	this.showCityList = function(){
		var obj = this.docObj.getElementById("undockcitylist");
		if (obj) obj.style.display = "block";
	}

	this.hideCityList = function(){
		var obj = this.docObj.getElementById("undockcitylist");
		if (obj) obj.style.display = "none";
	}

	this.setFrcContent = function(cityData) {
		var forecasts = cityData.forecasts;
		var contents = "<table border='0'  cellspacing='0' cellpadding='0'><tr>";
		for (var i=0; i<forecasts.length; i++) {
          	if (i==0) {
          		contents+=this.setFirstTD(forecasts[0]);
          		contents+=this.setSecondTD(forecasts[0], cityData.timeCreate);
          	}
          	else if (i<4) contents+=this.setTD(forecasts[i]);
          	if (i==4) contents+=this.setLastTD(forecasts[4]);
		}
		return contents + "</tr></table>";
	}

	this.setFirstTD = function(forecast) {
		var contents = "<td class='td0 fon_"+forecast.tod+"_"+forecast.cl+"'>";
		contents+=this.setFirstTDContent(forecast);
		return contents + "</td>";
	}

	this.setSecondTD = function(forecast, timeCreate) {
		var contents = "<td class='td1 fon_"+forecast.tod+"_"+forecast.cl+"'>";
		contents+=this.setSecondTDContent(forecast, timeCreate);
		return contents + "</td>";
	}

	this.setTD = function (forecast){
		var contents = "<td class='td fon_"+forecast.tod+"_"+forecast.cl+"'>";
		contents+=this.setTDContent(forecast);
		return contents + "</td>";
	}

	this.setLastTD = function (forecast){
		var contents = "<td class='td4 fon_"+forecast.tod+"_"+forecast.cl+"'>";
		contents+=this.setTDContent(forecast);
		return contents + "</td>";
	}

	this.setFirstTDContent = function(forecast) {
		var contents = "<table border='0'  cellspacing='0' cellpadding='0'>";
 			contents+="<tr><td class='undockdate'><td></tr>";
 			contents+="<tr><td class='undocktod'><td></tr>";
 			if ((forecast.tod==0) || (forecast.tod==3)) var classFFF = "classFFF";
 			else var classFFF = "";
 			contents+="<tr><td class='undockdate2 "+classFFF+"'>"+forecast.day+"<td></tr>";
 			contents+="<tr><td class='undockphenomena undockphenomena0 "+classFFF+"'>"+dictObj.monthes_r[forecast.month-1]+"<br>"+forecast.year+"<td></tr>";
 			contents+="<tr><td class='undocktemper undocktemper0 "+classFFF+"'>"+dictObj.descriptions[0]+":<td></tr>";
 			contents+="<tr><td class='undockhum undockhum0 "+classFFF+"'>"+dictObj.descriptions[1]+":<td></tr>";
 			contents+="<tr><td class='undockwind undockwind0'>"+dictObj.descriptions[2]+":<td></tr>";
		return contents + "</table>";
	}

	this.setSecondTDContent = function(forecast, timeCreate) {
		var contents = "<table width='100%' border='0'  cellspacing='0' cellpadding='0'>";
		contents+="<tr><td class='undockdate' style='font-size: 10px;'>"+this.getLastTimeUpdate(timeCreate)+"<td></tr>";
		if ((forecast.tod==0) || (forecast.tod==3)) var classFFF = "classFFF";
		else var classFFF = "";
		contents+="<tr><td class='undocktod text14 "+classFFF+"'>"+dictObj.tods[forecast.tod]+"<td></tr>";
		contents+="<tr><td class='undockphenomena'><img src='../res/icons/"+forecast.phenomena+".png'><td></tr>";
		contents+="<tr><td class='undocktemper text20 "+classFFF+"'>"+forecast.t+"&deg;<td></tr>";
		contents+="<tr><td class='undockhum "+classFFF+"'><b>"+forecast.hum+"%</b><td></tr>";
		if (forecast.wd != "calm") contents+="<tr><td class='undockwind'><b>"+forecast.wd+"<br>"+forecast.ws+" "+dictObj.descriptions[8]+"</b><td></tr>";
		else contents+="<tr><td class='undockwind'><b>"+dictObj.wind_directions[8]+"</b><td></tr>";
		return contents + "</table>";
	}

	this.setTDContent = function(forecast) {
		var contents = "<table width='100%' border='0'  cellspacing='0' cellpadding='0'>";
		contents+="<tr><td class='undockdate'><b>"+forecast.day+", "+dictObj.weekdays[forecast.weekday-1]+"</b><td></tr>";
		if ((forecast.tod==0) || (forecast.tod==3)) var classFFF = "classFFF";
		else var classFFF = "";
		contents+="<tr><td class='undocktod "+classFFF+"'>"+dictObj.tods[forecast.tod]+"<td></tr>";
		contents+="<tr><td class='undockphenomena'><img src='../res/icons/"+forecast.phenomena+".png'><td></tr>";
		contents+="<tr><td class='undocktemper "+classFFF+"'>"+forecast.t+"&deg;<td></tr>";
		contents+="<tr><td class='undockhum "+classFFF+"'>"+forecast.hum+"%<td></tr>";
		if (forecast.wd != "штиль") contents+="<tr><td class='undockwind'>"+forecast.wd+"<br>"+forecast.ws+" "+dictObj.descriptions[8]+"<td></tr>";
		else contents+="<tr><td class='undockwind'>"+forecast.wd+"<td></tr>";
		return contents + "</table>";
	}

	this.showNews = function () {
		//this.hideLayer("preloader2");
		this.showLayer('undocknewscontent');
		var contents = "<table width='100%' cellspacing='0' cellpadding='0'>";
		for(var i=0; i<arrayNews.length; i++){
			var news = arrayNews[i];
			contents+="<tr><td valign=\"top\"><a class=\"news_title\" href=\""+news.link+"\" target=\"_blank\">"+news.title+"</a></td></tr>";
			contents+="<tr><td class=\"news_description\" valign=\"top\">"+news.description+"</td></tr>";
		}
		contents+="</table>";
		this.docObj.getElementById("undocknewscontent").innerHTML = contents;
	}

	this.getLastTimeUpdate = function(dateVal) {
		var str = "";
		dateObj = new Date(dateVal);
		var hour = dateObj.getHours();
		if (hour<10) hour = "0"+hour;
		var minute = dateObj.getMinutes();
		if (minute<10) minute = "0"+minute;
		str = dictObj.descriptions[3]+" "+hour+":"+minute;
		return str;
	}

	this.showReloadButton = function() {
		var obj = this.docObj.getElementById("update_block");
		if (obj) obj.style.display = 'block';
		var opacity = 80;
		setTimeout(function () {
			var interval = setInterval(function() {
				opacity = opacity-10;
				obj.style.filter = 'alpha(opacity=' + opacity + ')';	
				if (opacity == 0) {
					clearInterval(interval);
					obj.style.display = 'none';
					obj.style.filter = 'alpha(opacity=80)';
				}	
			}, 50)
		}, 3000);
	}
}